// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
endglobals
native testFail takes string s returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_test_A_foo takes integer this returns integer
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	if B_typeId[this] <= 2 then
		set this = 1
	else
		set this = 2
	endif
	return this
endfunction

function dispatch_B_test_B_bar takes integer this returns integer
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.bar")
		else
			call error("Called B.bar on invalid object.")
		endif
	endif
	if B_typeId[this] <= 2 then
		set this = 3
	else
		set this = 4
	endif
	return this
endfunction

function new_C takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	return this
endfunction

function new_D takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 3
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 3
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer x1 = new_C()
	local integer x2 = new_D()
	local integer x3 = new_C()
	local integer x4 = new_D()
	if dispatch_A_test_A_foo(x1) != 1 then
		call testFail("1")
	endif
	if dispatch_A_test_A_foo(x2) != 2 then
		call testFail("2")
	endif
	if dispatch_B_test_B_bar(x3) != 3 then
		call testFail("3")
	endif
	if dispatch_B_test_B_bar(x4) != 4 then
		call testFail("4")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

