// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
real array C_ang_rad_0
real array C_ang_rad_1
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set C_firstFree = 0
	set C_maxIndex = 0
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function C_ang_rad_get takes integer index1, integer index2 returns real
	local real returnVal
	if index2 < 0 or index2 >= 2 then
		call error("Index out of Bounds")
	elseif index2 <= 0 then
		set returnVal = C_ang_rad_0[index1]
	else
		set returnVal = C_ang_rad_1[index1]
	endif
	return returnVal
endfunction

function C_ang_rad_set takes integer instanceId, integer arrayIndex, real value returns nothing
	if arrayIndex < 0 or arrayIndex >= 2 then
		call error("Index out of Bounds")
	elseif arrayIndex <= 0 then
		set C_ang_rad_0[instanceId] = value
	else
		set C_ang_rad_1[instanceId] = value
	endif
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_C()
	local real tuple_temp = 4.
	local real tuple_temp_1
	call C_ang_rad_set(c, 0, tuple_temp)
	set tuple_temp_1 = 2.
	call C_ang_rad_set(c, 1, tuple_temp_1)
	if C_ang_rad_get(c, 0) == 4. and C_ang_rad_get(c, 1) == 2. then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

